/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.scene.Scene
 *  fire.pb.scene.movable.God
 *  fire.pb.scene.movable.Role
 *  fire.pb.scene.movable.SceneTeam
 */
package fire.pb.scene.manager;

import fire.pb.scene.Scene;
import fire.pb.scene.manager.RoleManager;
import fire.pb.scene.movable.God;
import fire.pb.scene.movable.Role;
import fire.pb.scene.movable.SceneTeam;
import java.util.HashMap;
import java.util.Map;

public class SceneTeamManager {
    private static SceneTeamManager instance;
    private final Map<Long, SceneTeam> teams = new HashMap<Long, SceneTeam>();

    public final SceneTeam getTeamByID(long id) {
        return this.teams.get(id);
    }

    public void onCreateNewTeam(long teamID, long leaderID) {
        SceneTeam st = this.teams.get(teamID);
        if (null != st) {
            return;
        }
        st = God.createTeam((long)teamID, (long)leaderID);
        this.teams.put(teamID, st);
        st.broadcastTeam();
    }

    public void onDestroyTeam(long teamID) {
        SceneTeam st = this.teams.get(teamID);
        if (null == st) {
            return;
        }
        st.destroy();
        this.teams.remove(teamID);
    }

    public void onUpdateTeam(long teamid, int type, long roleid, long roleid2) {
        Scene.LOG.debug((Object)("OnUpdateTeam : teamid = " + teamid + ", type = " + type + ", roleid = " + roleid + ", roleid2 = " + roleid2));
        if (1 == type) {
            this.onCreateNewTeam(teamid, roleid);
            return;
        }
        if (2 == type) {
            this.onDestroyTeam(teamid);
            return;
        }
        SceneTeam st = this.teams.get(teamid);
        if (null == st) {
            Scene.LOG.error((Object)("OnUpdateTeam : 场景队伍为空, teamid = " + teamid));
            return;
        }
        Role r1 = RoleManager.getInstance().getRoleByID(roleid);
        if (null == r1) {
            Scene.LOG.info((Object)("OnUpdateTeam : 场景角色不存在, roleid = " + roleid + ", type = " + type));
            return;
        }
        switch (type) {
            case 3: {
                st.changeCapitan(r1);
                break;
            }
            case 4: {
                st.joinAsMember(r1);
                break;
            }
            case 5: {
                st.leaveFromTeam(r1);
                break;
            }
            case 6: {
                st.quitFromTeam(r1);
                break;
            }
            case 7: {
                Role r2 = RoleManager.getInstance().getRoleByID(roleid2);
                if (null == r2) {
                    return;
                }
                st.changeSeq(r1, r2);
                break;
            }
            case 8: {
                st.backToTeam(r1);
                break;
            }
            case 9: {
                st.leaveFromTeam(r1);
                break;
            }
            case 10: {
                st.quitFromTeam(r1);
                break;
            }
        }
        st.broadcastTeam();
    }

    public static SceneTeamManager getInstance() {
        if (null == instance) {
            instance = new SceneTeamManager();
        }
        return instance;
    }

    private SceneTeamManager() {
    }
}

